CONFIG ?= config.mk
include $(CONFIG)

INCLUDES := -I./ -I$(HDF5_INC) -I$(COMP_INC)
LDFLAGS := -L$(HDF5_LIB) -L$(COMP_LIB)
LDLIBS := -l$(HDF5_LIBNAME) -l$(COMP_LIBNAME)

OUT_LIBSO := lib$(OUT_LIBNAME).so

SOURCES := $(sort $(wildcard *.c))
OBJECTS := $(SOURCES:.c=.o)

.PHONY: all install uninstall check clean

all: $(OUT_LIBSO)

$(OUT_LIBSO): $(OBJECTS)
	$(CC) -shared $(CFLAGS) $(LDFLAGS) $(LDLIBS) -o $@ $^

%.o: %.c
	$(CC) -fPIC $(CFLAGS) $(INCLUDES) -c $<

install: $(OUT_LIBSO)
	@$(INSTALL) -d $(HDF5_PLUGIN_PATH)
	@$(INSTALL) -m 755 $(OUT_LIBSO) $(HDF5_PLUGIN_PATH)
	@echo "Set the following environment variables accordingly:"
	@echo export HDF5_PLUGIN_PATH=$(HDF5_PLUGIN_PATH)
	@echo export LD_LIBRARY_PATH=\$$LD_LIBRARY_PATH:$(HDF5_PLUGIN_PATH)

uninstall:
	$(RM) $(HDF5_PLUGIN_PATH)/$(OUT_LIBSO)

check:
	@echo using $(CONFIG)
	$(MAKE) -C $(TEST_DIR) all

clean:
	$(RM) *.o *.so*
	$(MAKE) -C $(TEST_DIR) clean

